; 

    .686                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive

    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    WndProc   PROTO :DWORD,:DWORD,:DWORD,:DWORD ; define procedure

    .data

    dlgname          db "MinRestWindowsDialog",0
    passwordprompt   db "                  ",0
    szMinimized      db "Consoles Minimized",0
    szRestored       db "Consoles Restored ",0

    ClassName        db "ConsoleWindowClass",0,0
    CaptionName      db "Sleep.exe",0
    align 4
    szBufClassName   db 256 dup (0)

    HandleArray      dd 256 dup (0)             ; was 30
    NumWinsMinimized dd 0
    LoopCounter      dd 0
    WindowsMinimized dd 0
    TempPassword     dd 0
    hInstance        dd 0    ; instance for dialogbox
    tmphWin          dd 0

; 
    
    .code

start:

    invoke GetModuleHandle, NULL
    mov    hInstance, eax
    invoke DialogBoxParam, hInstance, ADDR dlgname, NULL, ADDR WndProc, NULL
    invoke ExitProcess, eax

; -------------------------------------------------------------------------

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    .if uMsg == WM_COMMAND ; a button has been pressed

        .if wParam == 100       ; "Minimize "
            .if WindowsMinimized == 0
                mov eax,offset HandleArray
                mov LoopCounter,256
                mov NumWinsMinimized,0
                        
                push 0
                push offset CountNumberVisibleWindowsProcCallback
                call EnumWindows

                push SW_MINIMIZE
                call MinimizeOrRestoreWindows

                mov WindowsMinimized, 1
    
                invoke ShowWindow,hWin,SW_SHOW

                invoke SetDlgItemText, hWin, 150, addr szMinimized
            .endif
        .elseif wParam == 101   ; "Restore"
            .if WindowsMinimized == 1
               push SW_SHOW
               call MinimizeOrRestoreWindows

               push SW_RESTORE           ; SW_SHOW
               call MinimizeOrRestoreWindows

               invoke SetDlgItemText, hWin, 150, addr szRestored
               mov WindowsMinimized, 0
            .endif
        .elseif wParam == 200   ; exit button
            .if WindowsMinimized ==0
               invoke EndDialog,hWin,NULL
            .endif
        .endif
        
    .elseif uMsg == WM_CLOSE ; X button

        .if WindowsMinimized ==0
            invoke EndDialog,hWin,NULL
        .endif
        
    .endif

    xor eax,eax     ; THIS LINE IS KEY! Without it, no dialog "window" appears,
                    ; and the program goes into an infinite loop.
    ret
    
WndProc endp

; -------------------------------------------------------------------------

CountNumberVisibleWindowsProcCallback proc  hWin :DWORD, lParam :DWORD

    push ebx
    push eax
    push ecx
    push edx

    invoke IsWindowVisible,hWin                                   ; has WS_VISIBLE style
    .if eax == TRUE
       invoke  GetClassName, hWin, addr szBufClassName, 255       
       .if eax > 0                                                ; 0 failed,    > 0 number of characters in class name
          invoke IsIconic,hWin
          .if eax == 0                                            ; 0 minimized, > 0 not minimized
             mov eax, dword ptr szBufClassName+0                  ; 18+0 for ConsoleWindowClass 
             mov ebx, dword ptr szBufClassName+4
             mov ecx, dword ptr szBufClassName+8
             mov edx, dword ptr szBufClassName+12
             .if (dword ptr ClassName+0 == eax)
               .if (dword ptr ClassName+4 == ebx)
                 .if (dword ptr ClassName+8 == ecx)
                   .if (dword ptr ClassName+12 == edx)
                      mov eax, TRUE
                   .endif
                 .endif
               .endif
             .endif
          .else
             mov eax, FALSE
          .endif
       .endif
    .endif

    .if eax == TRUE
        mov ebx,NumWinsMinimized
        shl ebx,2                     ; ebx = NumWinsMinimized * 4
        add ebx,offset HandleArray    ; ebx = ebx + HandleArray address
        mov eax, hWin
        mov [ebx],eax
        inc NumWinsMinimized
    .endif

    pop edx
    pop ecx
    pop eax
    mov eax, 1  
    pop ebx
    ret

CountNumberVisibleWindowsProcCallback endp

; -------------------------------------------------------------------------

MinimizeOrRestoreWindows proc  MinOrRestore :DWORD

    push ebx
    push edx
    
    mov ebx,offset HandleArray
    mov LoopCounter,0

    loop_to_min:
        mov eax,[ebx]
        invoke ShowWindow,eax,MinOrRestore
        add ebx,4
        inc LoopCounter
        mov edx, NumWinsMinimized
    cmp LoopCounter, edx
    jl loop_to_min

    pop edx
    pop ebx
    ret

MinimizeOrRestoreWindows endp

; -------------------------------------------------------------------------

end start

; 